play.libs

## Class CronExpression

- java.lang.Object
- - play.libs.CronExpression

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class CronExpression
    extends java.lang.Object
    implements java.io.Serializable, java.lang.Cloneable

Thanks to Quartz project, https://quartz.dev.java.net

Provides a parser and evaluator for unix-like cron expressions. Cron expressions provide the ability to specify complex time combinations such as "At 8:00am every Monday through Friday" or "At 1:30am every last Friday of the month".

Cron expressions are comprised of 6 required fields and one optional field separated by white space. The fields respectively are described as follows:

Field Name |  | Allowed Values |  | Allowed Special Characters
--- | --- | --- | --- | ---
`Seconds` |  | `0-59` |  | `, - * /`
`Minutes` |  | `0-59` |  | `, - * /`
`Hours` |  | `0-23` |  | `, - * /`
`Day-of-month` |  | `1-31` |  | `, - * ? / L W`
`Month` |  | `1-12 or JAN-DEC` |  | `, - * /`
`Day-of-Week` |  | `1-7 or SUN-SAT` |  | `, - * ? / L #`
`Year (Optional)` |  | `empty, 1970-2099` |  | `, - * /`

The '*' character is used to specify all values. For example, "*" in the minute field means "every minute".

The '?' character is allowed for the day-of-month and day-of-week fields. It is used to specify 'no specific value'. This is useful when you need to specify something in one of the two fileds, but not the other.

The '-' character is used to specify ranges For example "10-12" in the hour field means "the hours 10, 11 and 12".

The ',' character is used to specify additional values. For example "MON,WED,FRI" in the day-of-week field means "the days Monday, Wednesday, and Friday".

The '/' character is used to specify increments. For example "0/15" in the seconds field means "the seconds 0, 15, 30, and 45". And "5/15" in the seconds field means "the seconds 5, 20, 35, and 50". Specifying '*' before the '/' is equivalent to specifying 0 is the value to start with. Essentially, for each field in the expression, there is a set of numbers that can be turned on or off. For seconds and minutes, the numbers range from 0 to 59. For hours 0 to 23, for days of the month 0 to 31, and for months 1 to 12. The "/" character simply helps you turn on every "nth" value in the given set. Thus "7/6" in the month field only turns on month "7", it does NOT mean every 6th month, please note that subtlety.

The 'L' character is allowed for the day-of-month and day-of-week fields. This character is short-hand for "last", but it has different meaning in each of the two fields. For example, the value "L" in the day-of-month field means "the last day of the month" - day 31 for January, day 28 for February on non-leap years. If used in the day-of-week field by itself, it simply means "7" or "SAT". But if used in the day-of-week field after another value, it means "the last xxx day of the month" - for example "6L" means "the last friday of the month". When using the 'L' option, it is important not to specify lists, or ranges of values, as you'll get confusing results.

The 'W' character is allowed for the day-of-month field. This character is used to specify the weekday (Monday-Friday) nearest the given day. As an example, if you were to specify "15W" as the value for the day-of-month field, the meaning is: "the nearest weekday to the 15th of the month". So if the 15th is a Saturday, the trigger will fire on Friday the 14th. If the 15th is a Sunday, the trigger will fire on Monday the 16th. If the 15th is a Tuesday, then it will fire on Tuesday the 15th. However if you specify "1W" as the value for day-of-month, and the 1st is a Saturday, the trigger will fire on Monday the 3rd, as it will not 'jump' over the boundary of a month's days. The 'W' character can only be specified when the day-of-month is a single day, not a range or list of days.

The 'L' and 'W' characters can also be combined for the day-of-month expression to yield 'LW', which translates to "last weekday of the month".

The '#' character is allowed for the day-of-week field. This character is used to specify "the nth" xxx day of the month. For example, the value of "6#3" in the day-of-week field means the third Friday of the month (day 6 = Friday and "#3" = the 3rd one in the month). Other examples: "2#1" = the first Monday of the month and "4#5" = the fifth Wednesday of the month. Note that if you specify "#5" and there is not 5 of the given day-of-week in the month, then no firing will occur that month.

The legal characters and the names of months and days of the week are not case sensitive.

NOTES:

- Support for specifying both a day-of-week and a day-of-month value is not complete (you'll need to use the '?' character in on of these fields).

See Also:
  Serialized Form

### Field Summary

Fields
`protected static java.lang.Integer` `ALL_SPEC`
`protected static int` `ALL_SPEC_INT`
`protected static int` `DAY_OF_MONTH`
`protected static int` `DAY_OF_WEEK`
`protected static java.util.Map<java.lang.String,java.lang.Integer>` `dayMap`
`protected java.util.TreeSet<java.lang.Integer>` `daysOfMonth`
`protected java.util.TreeSet<java.lang.Integer>` `daysOfWeek`
`protected boolean` `expressionParsed`
`protected static int` `HOUR`
`protected java.util.TreeSet<java.lang.Integer>` `hours`
`protected boolean` `lastdayOfMonth`
`protected boolean` `lastdayOfWeek`
`protected static int` `MINUTE`
`protected java.util.TreeSet<java.lang.Integer>` `minutes`
`protected static int` `MONTH`
`protected static java.util.Map<java.lang.String,java.lang.Integer>` `monthMap`
`protected java.util.TreeSet<java.lang.Integer>` `months`
`protected boolean` `nearestWeekday`
`protected static java.lang.Integer` `NO_SPEC`
`protected static int` `NO_SPEC_INT`
`protected int` `nthdayOfWeek`
`protected static int` `SECOND`
`protected java.util.TreeSet<java.lang.Integer>` `seconds`
`protected static int` `YEAR`
`protected java.util.TreeSet<java.lang.Integer>` `years`

### Constructor Summary

Constructors
Constructor and Description
`CronExpression(java.lang.String cronExpression)` Constructs a new `CronExpression` based on the specified parameter.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected void` `addToSet(int val, int end, int incr, int type)`
`protected void` `buildExpression(java.lang.String expression)`
`protected int` `checkNext(int pos, java.lang.String s, int val, int type)`
`java.lang.Object` `clone()`
`protected int` `findNextWhiteSpace(int i, java.lang.String s)`
`java.lang.String` `getCronExpression()`
`protected int` `getDayOfWeekNumber(java.lang.String s)`
`protected java.lang.String` `getExpressionSetSummary(java.util.ArrayList<java.lang.Integer> list)`
`protected java.lang.String` `getExpressionSetSummary(java.util.Set<java.lang.Integer> set)`
`java.lang.String` `getExpressionSummary()`
`java.util.Date` `getFinalFireTime()` NOT YET IMPLEMENTED: Returns the final time that the `CronExpression` will match.
`protected int` `getLastDayOfMonth(int monthNum, int year)`
`protected int` `getMonthNumber(java.lang.String s)`
`long` `getNextInterval(java.util.Date date)` Return the interval between the next valid date and the one after
`java.util.Date` `getNextInvalidTimeAfter(java.util.Date date)` Returns the next date/time after the given date/time which does not satisfy the expression
`java.util.Date` `getNextValidTimeAfter(java.util.Date date)` Returns the next date/time after the given date/time which satisfies the cron expression.
`protected int` `getNumericValue(java.lang.String s, int i)`
`protected java.util.TreeSet<java.lang.Integer>` `getSet(int type)`
`protected java.util.Date` `getTimeAfter(java.util.Date afterTime)`
`protected java.util.Date` `getTimeBefore(java.util.Date endTime)` NOT YET IMPLEMENTED: Returns the time before the given time that the `CronExpression` matches.
`java.util.TimeZone` `getTimeZone()` Returns the time zone for which this `CronExpression` will be resolved.
`protected play.libs.CronExpression.ValueSet` `getValue(int v, java.lang.String s, int i)`
`protected boolean` `isLeapYear(int year)`
`boolean` `isSatisfiedBy(java.util.Date date)` Indicates whether the given date satisfies the cron expression.
`static boolean` `isValidExpression(java.lang.String cronExpression)` Indicates whether the specified cron expression can be parsed into a valid cron expression
`protected void` `setCalendarHour(java.util.Calendar cal, int hour)` Advance the calendar to the particular hour paying particular attention to daylight saving problems.
`void` `setTimeZone(java.util.TimeZone timeZone)` Sets the time zone for which this `CronExpression` will be resolved.
`protected int` `skipWhiteSpace(int i, java.lang.String s)`
`protected int` `storeExpressionVals(int pos, java.lang.String s, int type)`
`java.lang.String` `toString()` Returns the string representation of the `CronExpression`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### SECOND

    protected static final int SECOND

See Also:
  Constant Field Values

#### MINUTE

    protected static final int MINUTE

See Also:
  Constant Field Values

#### HOUR

    protected static final int HOUR

See Also:
  Constant Field Values

#### DAY_OF_MONTH

    protected static final int DAY_OF_MONTH

See Also:
  Constant Field Values

#### MONTH

    protected static final int MONTH

See Also:
  Constant Field Values

#### DAY_OF_WEEK

    protected static final int DAY_OF_WEEK

See Also:
  Constant Field Values

#### YEAR

    protected static final int YEAR

See Also:
  Constant Field Values

#### ALL_SPEC_INT

    protected static final int ALL_SPEC_INT

See Also:
  Constant Field Values

#### NO_SPEC_INT

    protected static final int NO_SPEC_INT

See Also:
  Constant Field Values

#### ALL_SPEC

    protected static final java.lang.Integer ALL_SPEC

#### NO_SPEC

    protected static final java.lang.Integer NO_SPEC

#### monthMap

    protected static java.util.Map<java.lang.String,java.lang.Integer> monthMap

#### dayMap

    protected static java.util.Map<java.lang.String,java.lang.Integer> dayMap

#### seconds

    protected transient java.util.TreeSet<java.lang.Integer> seconds

#### minutes

    protected transient java.util.TreeSet<java.lang.Integer> minutes

#### hours

    protected transient java.util.TreeSet<java.lang.Integer> hours

#### daysOfMonth

    protected transient java.util.TreeSet<java.lang.Integer> daysOfMonth

#### months

    protected transient java.util.TreeSet<java.lang.Integer> months

#### daysOfWeek

    protected transient java.util.TreeSet<java.lang.Integer> daysOfWeek

#### years

    protected transient java.util.TreeSet<java.lang.Integer> years

#### lastdayOfWeek

    protected transient boolean lastdayOfWeek

#### nthdayOfWeek

    protected transient int nthdayOfWeek

#### lastdayOfMonth

    protected transient boolean lastdayOfMonth

#### nearestWeekday

    protected transient boolean nearestWeekday

#### expressionParsed

    protected transient boolean expressionParsed

### Constructor Detail

#### CronExpression

    public CronExpression(java.lang.String cronExpression)
                   throws java.text.ParseException

Constructs a new `CronExpression` based on the specified parameter.

Parameters:
  `cronExpression` - String representation of the cron expression the new object should represent
Throws:
  `java.text.ParseException` - if the string expression cannot be parsed into a valid `CronExpression`

### Method Detail

#### isSatisfiedBy

    public boolean isSatisfiedBy(java.util.Date date)

Indicates whether the given date satisfies the cron expression. Note that milliseconds are ignored, so two Dates falling on different milliseconds of the same second will always have the same result here.

Parameters:
  `date` - the date to evaluate
Returns:
  a boolean indicating whether the given date satisfies the cron expression

#### getNextValidTimeAfter

    public java.util.Date getNextValidTimeAfter(java.util.Date date)

Returns the next date/time after the given date/time which satisfies the cron expression.

Parameters:
  `date` - the date/time at which to begin the search for the next valid date/time
Returns:
  the next valid date/time

#### getNextInvalidTimeAfter

    public java.util.Date getNextInvalidTimeAfter(java.util.Date date)

Returns the next date/time after the given date/time which does not satisfy the expression

Parameters:
  `date` - the date/time at which to begin the search for the next invalid date/time
Returns:
  the next valid date/time

#### getNextInterval

    public long getNextInterval(java.util.Date date)

Return the interval between the next valid date and the one after

Parameters:
  `date` - the date/time at which to begin the search
Returns:
  the number of milliseconds between the next valid and the one after

#### getTimeZone

    public java.util.TimeZone getTimeZone()

Returns the time zone for which this `CronExpression` will be resolved.

Returns:
  Returns the time zone

#### setTimeZone

    public void setTimeZone(java.util.TimeZone timeZone)

Sets the time zone for which this `CronExpression` will be resolved.

Parameters:
  `timeZone` - The given time zone

#### toString

    public java.lang.String toString()

Returns the string representation of the `CronExpression`

Overrides:
  `toString` in class `java.lang.Object`
Returns:
  a string representation of the `CronExpression`

#### isValidExpression

    public static boolean isValidExpression(java.lang.String cronExpression)

Indicates whether the specified cron expression can be parsed into a valid cron expression

Parameters:
  `cronExpression` - the expression to evaluate
Returns:
  a boolean indicating whether the given expression is a valid cron expression

#### buildExpression

    protected void buildExpression(java.lang.String expression)
                            throws java.text.ParseException

Throws:
  `java.text.ParseException`

#### storeExpressionVals

    protected int storeExpressionVals(int pos,
                                      java.lang.String s,
                                      int type)
                               throws java.text.ParseException

Throws:
  `java.text.ParseException`

#### checkNext

    protected int checkNext(int pos,
                            java.lang.String s,
                            int val,
                            int type)
                     throws java.text.ParseException

Throws:
  `java.text.ParseException`

#### getCronExpression

    public java.lang.String getCronExpression()

#### getExpressionSummary

    public java.lang.String getExpressionSummary()

#### getExpressionSetSummary

    protected java.lang.String getExpressionSetSummary(java.util.Set<java.lang.Integer> set)

#### getExpressionSetSummary

    protected java.lang.String getExpressionSetSummary(java.util.ArrayList<java.lang.Integer> list)

#### skipWhiteSpace

    protected int skipWhiteSpace(int i,
                                 java.lang.String s)

#### findNextWhiteSpace

    protected int findNextWhiteSpace(int i,
                                     java.lang.String s)

#### addToSet

    protected void addToSet(int val,
                            int end,
                            int incr,
                            int type)
                     throws java.text.ParseException

Throws:
  `java.text.ParseException`

#### getSet

    protected java.util.TreeSet<java.lang.Integer> getSet(int type)

#### getValue

    protected play.libs.CronExpression.ValueSet getValue(int v,
                                                         java.lang.String s,
                                                         int i)

#### getNumericValue

    protected int getNumericValue(java.lang.String s,
                                  int i)

#### getMonthNumber

    protected int getMonthNumber(java.lang.String s)

#### getDayOfWeekNumber

    protected int getDayOfWeekNumber(java.lang.String s)

#### getTimeAfter

    protected java.util.Date getTimeAfter(java.util.Date afterTime)

#### setCalendarHour

    protected void setCalendarHour(java.util.Calendar cal,
                                   int hour)

Advance the calendar to the particular hour paying particular attention to daylight saving problems.

Parameters:
  `cal` - The given calendar
  `hour` - The hour to set

#### getTimeBefore

    protected java.util.Date getTimeBefore(java.util.Date endTime)

NOT YET IMPLEMENTED: Returns the time before the given time that the `CronExpression` matches.

Parameters:
  `endTime` - The given time
Returns:
  Returns the time before the given time

#### getFinalFireTime

    public java.util.Date getFinalFireTime()

NOT YET IMPLEMENTED: Returns the final time that the `CronExpression` will match.

Returns:
  Returns the final time

#### isLeapYear

    protected boolean isLeapYear(int year)

#### getLastDayOfMonth

    protected int getLastDayOfMonth(int monthNum,
                                    int year)

#### clone

    public java.lang.Object clone()

Overrides:
  `clone` in class `java.lang.Object`